import { world, system } from "@minecraft/server"

system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    const player = data.sourceEntity
    if(id === "gst:check_pieces") {
        const entities = world.getDimension('overworld').getEntities({ families: ["i"] });
        for(const entity of entities) {
            if(entity?.typeId != 'gst:i_piece') return;
            const type = entity.getProperty('gst:type');
            const typeString = JSON.stringify(type)
            const rotate = entity.getProperty('gst:rotate');
            const {x, y, z} = entity.location;
            const block = entity.dimension.getBlock({ x: x, y: y, z: z });
            if(entity.typeId === "gst:i_piece") {
                if(rotate == 0 && block.below(1).isAir) return;
                else if(rotate == 0 && !block.below(1).isAir) {
                    system.runTimeout(() => {
                        if(!entity.isValid() || rotate == 0 && block.below(1).isAir) return;
                        entity.runCommandAsync(`fill ~~~ ~~3~ gst:piece_block ["gst:piece"="i","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync('scriptevent gst:piece_placed i');
                        system.runTimeout(() => {
                            if(!entity.isValid()) return;
                            entity.remove();
                        },2);
                    },10);
                    return;
                }
                if(rotate == 1 && block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir && block.offset({ x: 0, y: -1, z: -2}).isAir && block.offset({ x: 0, y: -1, z: -3 }).isAir) return;
                else if(rotate == 1 && (!block.below(1).isAir || !block.offset({ x: 0, y: -1, z: -1 }).isAir || !block.offset({ x: 0, y: -1, z: -2}).isAir || !block.offset({ x: 0, y: -1, z: -3 }).isAir)) {
                    system.runTimeout(() => {
                        if(!entity.isValid() || rotate == 1 && block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir && block.offset({ x: 0, y: -1, z: -2}).isAir && block.offset({ x: 0, y: -1, z: -3 }).isAir) return;
                        entity.runCommandAsync(`fill ~~~ ~~~-3 gst:piece_block ["gst:piece"="i","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync('scriptevent gst:piece_placed i');
                        system.runTimeout(() => {
                            if(!entity.isValid()) return;
                            entity.remove();
                        },2);
                    },10);
                    return;
                }
            }// i piece ^^^
        }// const entity
    }// Check pieces ^^^
});