import { world, system } from "@minecraft/server"

system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    const player = data.sourceEntity
    if(id === "gst:check_pieces") {
        const entities = world.getDimension('overworld').getEntities({ families: ["o"] });
        for(const entity of entities) {
            if(entity?.typeId != 'gst:o_piece') return;
            const type = entity.getProperty('gst:type');
            const typeString = JSON.stringify(type)
            const rotate = entity.getProperty('gst:rotate');
            const {x, y, z} = entity.location;
            const block = entity.dimension.getBlock({ x: x, y: y, z: z });
            if(block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir) return;
            else if(!(block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir)) {
                system.runTimeout(() => {
                    if(!entity.isValid() || block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir) return;
                    entity.runCommandAsync(`fill ~~~ ~~1~-1 gst:piece_block ["gst:piece"="o","gst:type"=${typeString}] replace air`);
                    entity.runCommandAsync('scriptevent gst:piece_placed o');
                    system.runTimeout(() => {
                        if(!entity.isValid()) return;
                        entity.remove();
                    },2);
                },10);
            }
        }// const entity
    }// Check pieces ^^^
});