import { world, system } from "@minecraft/server"

system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    const player = data.sourceEntity
    if(id === "gst:move_pieces") {
        const entities = world.getDimension('overworld').getEntities({ families: ["o"] });
        for(const entity of entities) {
            if(entity?.typeId != 'gst:o_piece') return;
            const type = entity.getProperty('gst:type');
            const typeString = JSON.stringify(type)
            const rotate = entity.getProperty('gst:rotate');
            const {x, y, z} = entity.location;
            const block = entity.dimension.getBlock({ x: x, y: y, z: z });
            if(message === "down") {
                if(block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir) {
                    entity.teleport({ x: x, y: y -1, z: z });
                }
                system.runTimeout(() => {
                    if(!entity.isValid()) return;
                    entity.runCommandAsync('scriptevent gst:check_pieces')
                },2);
                return;
            }// Down ^^^
            if(message === "left") {
                if(block.offset({ x: 0, y: 0, z: -2 }).isAir && block.offset({ x: 0, y: 1, z: -2 }).isAir) {
                    entity.teleport({ x: x, y: y, z: z -1 });
                }
                system.runTimeout(() => {
                    if(!entity.isValid()) return;
                    entity.runCommandAsync('scriptevent gst:check_pieces')
                },2);
                return;
            }// Left ^^^
            if(message === "right") {
                if(block.offset({ x: 0, y: 0, z: 1 }).isAir && block.offset({ x: 0, y: 1, z: 1 }).isAir) {
                    entity.teleport({ x: x, y: y, z: z +1 });
                }
                system.runTimeout(() => {
                    if(!entity.isValid()) return;
                    entity.runCommandAsync('scriptevent gst:check_pieces')
                },2);
                return;
            }// Right ^^^
        }// const entity ^^^
    }// Move pieces ^^^
})