import { world, system } from "@minecraft/server"

system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    const player = data.sourceEntity
    if(id === "gst:check_pieces") {
        const entities = world.getDimension('overworld').getEntities({ families: ["t"] });
        for(const entity of entities) {
            if(entity?.typeId != 'gst:t_piece') return;
            const type = entity.getProperty('gst:type');
            const typeString = JSON.stringify(type)
            const rotate = entity.getProperty('gst:rotate');
            const {x, y, z} = entity.location;
            const block = entity.dimension.getBlock({ x: x, y: y, z: z });
            if(entity.typeId === "gst:t_piece") {
                if(rotate == 0 && block.isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir && block.offset({ x: 0, y: 0, z: -2 }).isAir) return;
                else if(rotate == 0 && (!block.isAir || !block.offset({ x: 0, y: -1, z: -1 }).isAir || !block.offset({ x: 0, y: 0, z: -2 }).isAir)) {
                    system.runTimeout(() => {
                        if(!entity.isValid() || (rotate == 0 && block.isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir && block.offset({ x: 0, y: 0, z: -2 }).isAir)) return;
                        entity.runCommandAsync(`fill ~~~-1 ~~~-1 gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync(`fill ~~1~ ~~1~-2 gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync('scriptevent gst:piece_placed t');
                        system.runTimeout(() => {
                            if(!entity.isValid()) return;
                            entity.remove();
                        },2);
                    },10);
                    return;
                }// rot_a ^^^
                if(rotate == 1 && block.below(1).isAir && block.offset({ x: 0, y: 0, z: -1 }).isAir) return;
                else if(rotate == 1 && (!block.below(1).isAir || !block.offset({ x: 0, y: 0, z: -1 }).isAir)) {
                    system.runTimeout(() => {
                        if(!entity.isValid() || (rotate == 1 && block.below(1).isAir && block.offset({ x: 0, y: 0, z: -1 }).isAir)) return;
                        entity.runCommandAsync(`fill ~~~ ~~2~ gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync(`fill ~~1~-1 ~~1~-1 gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync('scriptevent gst:piece_placed t');
                        system.runTimeout(() => {
                            if(!entity.isValid()) return;
                            entity.remove();
                        },2);
                    },10);
                    return;
                }// rot_b ^^^
                if(rotate == 2 && block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir && block.offset({ x: 0, y: -1, z: -2 }).isAir) return;
                else if(rotate == 2 && (!block.below(1).isAir || !block.offset({ x: 0, y: -1, z: -1 }).isAir || !block.offset({ x: 0, y: -1, z: -2 }).isAir)) {
                    system.runTimeout(() => {
                        if(!entity.isValid() || (rotate == 2 && block.below(1).isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir && block.offset({ x: 0, y: -1, z: -2 }).isAir)) return;
                        entity.runCommandAsync(`fill ~~~ ~~~-2 gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync(`fill ~~1~-1 ~~1~-1 gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync('scriptevent gst:piece_placed t');
                        system.runTimeout(() => {
                            if(!entity.isValid()) return;
                            entity.remove();
                        },2);
                    },10);
                    return;
                }// rot_c ^^^
                if(rotate == 3 && block.isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir) return;
                else if(rotate == 3 && (!block.isAir || !block.offset({ x: 0, y: -1, z: -1 }).isAir)) {
                    system.runTimeout(() => {
                        if(!entity.isValid() || (rotate == 3 && block.isAir && block.offset({ x: 0, y: -1, z: -1 }).isAir)) return;
                        entity.runCommandAsync(`fill ~~1~ ~~1~ gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync(`fill ~~~-1 ~~2~-1 gst:piece_block ["gst:piece"="t","gst:type"=${typeString}] replace air`);
                        entity.runCommandAsync('scriptevent gst:piece_placed t');
                        system.runTimeout(() => {
                            if(!entity.isValid()) return;
                            entity.remove();
                        },2);
                    },10);
                    return;
                }// rot_d ^^^
            }// t piece ^^^
        }// const entity
    }// Check pieces ^^^
});