import { world, system } from "@minecraft/server"

system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    const player = data.sourceEntity
    if (id === "gst:rotate_pieces") {
        const entities = world.getDimension('overworld').getEntities({ families: ["z"] });
        for(const entity of entities) {
            if(entity?.typeId != 'gst:z_piece') return;
            const rotate = entity.getProperty('gst:rotate');
            const {x, y, z} = entity.location;
            const block = entity.dimension.getBlock({ x: x, y: y, z: z });
            if(rotate == 1 && block.isAir && block.offset({ x: 0, y: 1, z: -2 }).isAir) {
                entity.setProperty('gst:rotate', 0);
                entity.runCommandAsync('execute at @a run playsound random.bow @a ~~~ 0.5 0.33');
            }
            else if(rotate == 0 && block.above(1).isAir && block.above(2).isAir) {
                entity.setProperty('gst:rotate', 1);
                entity.runCommandAsync('execute at @a run playsound random.bow @a ~~~ 0.5 0.33');
            }
            system.runTimeout(() => {
                if(!entity.isValid()) return;
                entity.runCommandAsync('scriptevent gst:check_pieces')
            },2);
        }// const entity
    }// Rotate pieces ^^^
});