import { world, system } from '@minecraft/server'

const mapSystem = world.getDimension('overworld');
let xScore = 1

system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    if(id == 'gst:check_full_lines') {
        const line = Number(message)
        const blockList = [
        { x: 20, y: line, z: 21 },
        { x: 20, y: line, z: 22 },
        { x: 20, y: line, z: 23 },
        { x: 20, y: line, z: 24 },
        { x: 20, y: line, z: 25 },
        { x: 20, y: line, z: 26 },
        { x: 20, y: line, z: 27 },
        { x: 20, y: line, z: 28 },
        { x: 20, y: line, z: 29 },
        { x: 20, y: line, z: 30 }
        ]
        const blocks = blockList.map(block => mapSystem.getBlock(block));
        const fullLine = blocks.filter(block => block.isAir);
        if(fullLine.length == 0) {
            for(const player of world.getAllPlayers()) {
                const linesDestroyed = world.scoreboard.getObjective('gst:lines_destroyed').getScore(player);
                if(linesDestroyed >= 10 && linesDestroyed < 25) {
                    xScore = 2
                }
                else if(linesDestroyed >= 25) {
                    xScore = 3
                }
                else {
                    xScore = 1
                }
                world.scoreboard.getObjective('gst:score').addScore(player, 100*xScore);
                world.scoreboard.getObjective('gst:lines_destroyed').addScore(player, 1);
                player.playSound('score.gst');
                player.runCommandAsync(`execute positioned 20 ${message} 21 run fill ~~~ ~~~9 air replace gst:piece_block`);
                system.runTimeout(() => {
                    player.runCommandAsync('setblock -7 130 27 redstone_block');
                },2);
            }
            return;
        }
        mapSystem.runCommandAsync('setblock -9 109 27 redstone_block');
        return;
    }
});