import { world, system } from "@minecraft/server"
import { Main } from '../menus.js'
//
let mapName = ' §g + §6Block§ePuzzle §g+§r '
let prgh = '§g --------------§r'
let end = '§g  +  --------  +'
let next = '§k?'
//
system.afterEvents.scriptEventReceive.subscribe(data => {
    const { id, message } = data;
    if(id === "gst:rename_entity") {
        const entities = world.getDimension('overworld').getEntities({ families: ['gst_button']});
        for(const entity of entities) {
            if(entity?.typeId == 'gst:start_button') {
                entity.nameTag = '\n§aPress to Start'
            }
            if(entity?.typeId == 'gst:stats_button') {
                entity.nameTag = '\n§6Stats'
            }
            if(entity?.typeId == 'gst:background_button') {
                for(const player of world.getAllPlayers()) {
                    const type = player.getProperty('gst:type');
                    entity.nameTag = `\n§dBackgrounds\n> §f${type} <`
                }
            }
        }
        return;
    }
    if(id === "gst:start") {
        for(const player of world.getAllPlayers()) {
            world.scoreboard.getObjective('gst:games_played').addScore(player, 1);
            player.setProperty('gst:time', 30);
        }
        world.getDimension('overworld').runCommandAsync('function gst/reset_pieces_score');
        system.run(() => {
            const run = system.runInterval(() => {
                const players = world.getAllPlayers();
                for(const player of players) {
                    const maxTime = 30
                    const time = player.getProperty("gst:time");
                    const start = player.getProperty("gst:start");
                    const score = world.scoreboard.getObjective('gst:score').getScore(player);
                    const nextPiece = world.scoreboard.getObjective('gst:next_piece').getScore(player);
                    const linesDestroyed = world.scoreboard.getObjective('gst:lines_destroyed').getScore(player);
                    const nextPieceArray = ['§k?','','','','','','',''];
                    if(next != nextPieceArray[nextPiece]) next = nextPieceArray[nextPiece];
                    if(start == false) {
                        player.setProperty('gst:time', 10);
                        player.runCommandAsync('function gst/reset_game');
                        system.clearRun(run);
                        return;
                    } else if(time === 0) {
                        for(const player of world.getAllPlayers()) {
                            player.onScreenDisplay.setActionBar('§cGame Over!');
                            player.playSound('game_over.gst');
                            const score = world.scoreboard.getObjective('gst:score').getScore(player);
                            const highscore = world.scoreboard.getObjective('gst:highscore').getScore(player);
                            if(score > highscore) {
                                world.scoreboard.getObjective('gst:highscore').setScore(player, score);
                                world.sendMessage({'rawtext':[{'translate':'gst.new_score.message'},{'text':`§e${score}`}]});
                            } else {
                                world.sendMessage({'rawtext':[{'translate':'gst.score.message'},{'text':`§f${score}`}]});
                            }
                            system.runTimeout(() => {
                                player.setProperty('gst:start', false);
                            },5);
                        }
                    } else {
                        if(linesDestroyed == 0) {
                            player.setProperty('gst:time', time > 0 ? time - 1 : 0);
                        }
                        else if(linesDestroyed > 0 && linesDestroyed < 20) {
                            player.setProperty('gst:time', time > 1 ? time - 2 : 0);
                        }
                        else if(linesDestroyed >= 20 && linesDestroyed < 40) {
                            player.setProperty('gst:time', time > 2 ? time - 3 : 0);
                        }
                        else if(linesDestroyed >= 40) {
                            player.setProperty('gst:time', time > 3 ? time - 4 : 0);
                        }
                        const green = '§a|§r'.repeat(time);
                        const red = '§c|§r'.repeat(maxTime - time);
                        player.onScreenDisplay.setTitle({'rawtext':[{'text':`${mapName}\n${prgh}\n  ${next}§r\n  ${score}\n  ${green + red}§r\n${prgh}\n${end}`}]});
                    }
                }
            },20);
        });
    }
});

world.afterEvents.playerSpawn.subscribe(({ player, initialSpawn }) => {
    if(!initialSpawn) return;
    player.setProperty('gst:start', false);
    player.setProperty('gst:time', 30);
    if(!player.hasTag('initial_message')) {
        player.runCommandAsync('function help');
        player.addTag('initial_message');
    } else {
        player.runCommandAsync('tellraw @a {"rawtext":[{"translate":"gst.message_10.chat"},{"text":"\n§f/function help§r\n\n"}]}');
    }
    player.runCommandAsync('function gst/reset_game');
});

world.afterEvents.entityHitEntity.subscribe(({ damagingEntity, hitEntity }) => {
    if(hitEntity?.typeId === "gst:start_button") {
        hitEntity.runCommandAsync('setblock -7 109 29 redstone_block');
        damagingEntity.playSound('start.gst');
    }
    else if(hitEntity?.typeId === "gst:stats_button") {
        Main.Stats(damagingEntity);
        damagingEntity.playSound('random.click');
    }
    else if(hitEntity?.typeId === "gst:background_button") {
        const player = damagingEntity;
        const type = player.getProperty('gst:type');
        player.playSound('random.click');
        if(type == 'default') {
            player.setProperty('gst:type', 'classic');
        }
        else if(type == 'classic') {
            player.setProperty('gst:type', 'retro');
        }
        else if(type == 'retro') {
            player.setProperty('gst:type', 'wood');
        }
        else if(type == 'wood') {
            player.setProperty('gst:type', 'bricks');
        }
        else if(type == 'bricks') {
            player.setProperty('gst:type', 'wool');
        }
        else if(type == 'wool') {
            player.setProperty('gst:type', 'default');
        }
        system.runTimeout(() => {
            const typeBackground = player.getProperty('gst:type');
            hitEntity.nameTag = `\n§dBackgrounds\n> §f${typeBackground} <`
            const backgrounds = player.dimension.getEntities({ type: 'gst:background' });
            for(const background of backgrounds) {
                background.triggerEvent(`gst:spawn_${typeBackground}`);
            }
        },2);
    }
});